/**
\file cs.h

\brief Header for counting semaphores for the avr thread library.

\author R. M&uuml;ller

*/

/*! Structure of a semaphore data type

The semaphore value is preset with 0. The event variable should be treated
as a opaque value.
*/
typedef struct Sema_cs
{
   /*!  the value; if <0, if is the number of waiting threads \n
        if >0, it is the number of possible requests without blocking */
   volatile int value;  
   /*! the event, which will block the waiting threads */
   volatile avr_thread_event e; 
} Sema_cs;

void request_cs(struct Sema_cs * s);
void release_cs(struct Sema_cs * s);

